#ifndef CONFIG_MESSAGE_H
#define CONFIG_MESSAGE_H

#include <Message.h>
#include <File.h>

#define CONFIG_VERSION        0x0100

#define CONFIG_VERSION_FIELD  "Version"
#define CONFIG_MODULE_FIELD   "Module"
#define CONFIG_DRIVER_FIELD   "Driver"
#define CONFIG_REMOTE_FIELD   "Remote"

class ConfigMessage : public BMessage
{
   public:
      ConfigMessage(char *psz_File);
      ~ConfigMessage();

      status_t Flush(void);
      
      status_t GetModule(char *psz_Module);
      status_t SetModule(char *psz_Module);
      status_t GetDriver(char *psz_Driver);
      status_t SetDriver(char *psz_Driver);
      
      status_t GetFirstRemote(char *psz_Remote);
      status_t GetNextRemote(char *psz_Remote);
      status_t AddRemote(char *psz_Remote);
      status_t DelRemote(char *psz_Remote);
   
   private:
      BFile *pc_ConfigFile;
      uint8 i_RemoteIndex;
};

#endif
