#ifndef PREFERENCE_H
#define PREFERENCE_H

#include <Messenger.h>

#include "ConfigMessage.h"
#include "ModuleGui.h"
#include "RemoteGui.h"
#include "BercDefs.h"

#define BG_COLOR ((rgb_color) {230,230,230,0})

#define W_WIDTH   200
#define W_HEIGHT  290

class MainWindow : public BWindow
{
   public:
      MainWindow(BRect r);
      ~MainWindow(void);
      void MessageReceived(BMessage *message);
      bool QuitRequested();

      status_t RemoteAddRequest(BMessage *message);
   
   private:
      /* methods */
      status_t Message2Gui(void);
      status_t SwitchDaemonState(void);
      status_t RestartDaemon(void);

      /* variables */
      BView          *pc_MainView;
      ConfigMessage  *pc_ConfigMessage;
      ModuleGui      *pc_ModuleGui;
      RemoteGui      *pc_RemoteGui;
      BButton        *pc_StopButton, *pc_ApplyButton;

      BMessenger     c_BercMessenger;
};

class Preference : public BApplication
{
   public :
      Preference();
      void MessageReceived(BMessage *message);

   private:
      MainWindow  *pc_MainWindow;
};

#endif
