#ifndef REMOTEGUI_H
#define REMOTEGUI_H

#include <FilePanel.h>
#include <View.h>
#include <ListView.h>
#include <ScrollView.h>
#include <ListItem.h>

#define REMOTE_STRING_SIZE 255
#define REMOTE_MAX_REMOTE  16

typedef struct
{
   char short_name[REMOTE_STRING_SIZE];
   char long_name[REMOTE_STRING_SIZE];
   BStringItem *item;
} TS_Remote;

class RemoteGui
{
   public:
      RemoteGui(BView *pc_ParentView, uint32 i_Top);
      ~RemoteGui(void);

      status_t AddRemote(char *sz_Remote);
      status_t DelRemote(char *sz_DeletedRemote);
      
   private:
      /* methods */
      status_t AddRemoteToList(char *sz_Remote);
      status_t DelRemoteFromList(char *sz_Remote);
      TS_Remote   *FindRemoteByItem(BListItem  *pc_Item);

      /* variables */
      TS_Remote   as_Remote[REMOTE_MAX_REMOTE];
      BListView   *pc_RemoteListView;
      BScrollView *pc_RemoteScrollView;
      BFilePanel  *pc_RemoteSelect;
};

#endif
