#include <Alert.h>

#include "BercServerFilter.h"
#include "BercServerFilter.h"
#include "EventHandler.h"

class BInputServerFilter;

BInputServerFilter * instantiate_input_filter()
{
   return new BercServerFilter;
}

BercServerFilter::BercServerFilter()
{
   BAlert *ErrorAlert;
   pc_EventHandler = new(EventHandler);
   if(pc_EventHandler != NULL)
   {
      c_EventMessenger = BMessenger(pc_EventHandler);
      pc_EventHandler->Run();
   }
   else
   {
      ErrorAlert = new BAlert("Berc Filter Error", "Error while creating event
            handler", "OK",NULL,NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT);
      ErrorAlert->Go(NULL);
   }
}

BercServerFilter::~BercServerFilter()
{
   if (pc_EventHandler->Lock()) pc_EventHandler->Quit();
}

status_t BercServerFilter::InitCheck()
{
   return B_NO_ERROR;
}

filter_result BercServerFilter::Filter(BMessage *pc_Msg, BList * outlist)
{
   filter_result i_ret = B_DISPATCH_MESSAGE;

   if(pc_EventHandler->MessageIsForMe(pc_Msg) == true)
   {
      BMessage *pc_HandlerMsg;
      BAlert *ErrorAlert;

      pc_HandlerMsg = new BMessage(*pc_Msg);       /* duplicate the message      */
      c_EventMessenger.SendMessage(pc_HandlerMsg); /* and send it to the handler */
      i_ret = B_SKIP_MESSAGE;    /* tell input server to skip the message  */
   }
   return(i_ret);
}
