#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "EventHandler.h"
#include "RcDefs.h"
    
EventHandler::EventHandler()
{
   b_MuteState = 0;
}

EventHandler::~EventHandler()
{
}

bool EventHandler::MessageIsForMe(BMessage *pc_Msg)
{
   bool b_ret = false;
   bool     b_MessageIsFromBerc;
   uint32   i_UnmappedKey;   
   
   switch(pc_Msg->what)
   {
      case B_UNMAPPED_KEY_DOWN:
         /* chekc that it is a Berc Message */
         if(pc_Msg->FindBool("berc:key", &b_MessageIsFromBerc) == B_OK)
         {               
            if(pc_Msg->FindInt32((const char*)"key", (int32*)&i_UnmappedKey) == B_OK)
            {
               switch(i_UnmappedKey)
               {
                  case RC_KEY_POWER:
                  case RC_KEY_MUTE:
                  case RC_KEY_VOLUME_UP:
                  case RC_KEY_VOLUME_DOWN:
                     b_ret = true;
                     break;
               }
            }
            /* we do not free sz_BercString because it belongs to the message */
         }
         break;
   }
   return(b_ret);
}

void EventHandler :: MessageReceived(BMessage * pc_Msg)
{
   uint32   i_UnmappedKey;
   
   switch(pc_Msg->what)
   {
      case B_UNMAPPED_KEY_DOWN:
      {
         if(pc_Msg->FindInt32((const char*)"key", (int32*)&i_UnmappedKey) == B_OK)
         {
            switch(i_UnmappedKey)
            {
               case RC_KEY_POWER:
                  c_Shutdown.DoShutdown();
                  break;
                  
               case RC_KEY_MUTE:
                  b_MuteState = 1 - b_MuteState;
                  c_Volume.SetAudioVolume(e_VolumeCmdMute, b_MuteState);
                  break;
                  
               case RC_KEY_VOLUME_UP:
                  c_Volume.SetAudioVolume(e_VolumeCmdLevel, 1);
                  break;
                  
               case RC_KEY_VOLUME_DOWN:
                  c_Volume.SetAudioVolume(e_VolumeCmdLevel, -1);
                  break;
            }
         }
      }
      break;      
   }   
}
