//#include "ToolsTester.h"
#include <Application.h>
#include <Button.h>
#include <TextControl.h>
#include <Alert.h>
#include <String.h>
#include <stdio.h>
#include <View.h>
#include <GraphicsDefs.h>

#include "ToolsTester.h"
#include "../../../input_addon/RcDefs.h"

ToolsTester MyApp;
BButton *pc_MuteButton;
BButton *pc_VolUpButton;
BButton *pc_VolDownButton;
BButton *pc_PowerButton;

int main()
{
   MyApp.Run();
   return 0;
}

ToolsTester::ToolsTester() : BApplication("application/x-vnd.zadig.BercFilterClassTester")
{
   BRect posfenetre(100,100,200,300);

   pc_EventHandler = new(EventHandler);
   if(pc_EventHandler != NULL)
   {
      c_EventMessenger = BMessenger(pc_EventHandler);
      pc_EventHandler->Run();
   }

   new MainWindow(posfenetre);
}

void ToolsTester::ButtonPressed(void)
{
   BMessage* event;

   event = new BMessage(B_UNMAPPED_KEY_DOWN);
   if(event == NULL)
      return;
   event->AddInt32("key", RC_KEY_MUTE);
      
   if(pc_EventHandler->MessageIsForMe(event) == true)
   {
      BMessage *pc_HandlerMsg;
      pc_HandlerMsg = new BMessage(*event);       /* duplicate the message      */
      c_EventMessenger.SendMessage(pc_HandlerMsg); /* and send it to the handler */
   }
}

void ToolsTester::PowerPressed(void)
{
   BMessage* event;
   BMessage *pc_HandlerMsg;

   event = new BMessage(B_UNMAPPED_KEY_DOWN);
   if(event == NULL)
      return;
   event->AddInt32("key", RC_KEY_POWER);
      
   pc_HandlerMsg = new BMessage(*event);       /* duplicate the message      */
   c_EventMessenger.SendMessage(pc_HandlerMsg); /* and send it to the handler */
}
void ToolsTester::VolumeUpPressed(void)
{
   BMessage* event;
   BMessage *pc_HandlerMsg;

   event = new BMessage(B_UNMAPPED_KEY_DOWN);
   if(event == NULL)
      return;
   event->AddInt32("key", RC_KEY_VOLUME_UP);
      
   pc_HandlerMsg = new BMessage(*event);       /* duplicate the message      */
   c_EventMessenger.SendMessage(pc_HandlerMsg); /* and send it to the handler */
}
void ToolsTester::VolumeDownPressed(void)
{
   BMessage* event;

   event = new BMessage(B_UNMAPPED_KEY_DOWN);
   if(event == NULL)
      return;
   event->AddInt32("key", RC_KEY_VOLUME_DOWN);
   
   if(pc_EventHandler->MessageIsForMe(event) == true)
   {
      BMessage *pc_HandlerMsg;

      pc_HandlerMsg = new BMessage(*event);       /* duplicate the message      */
      c_EventMessenger.SendMessage(pc_HandlerMsg); /* and send it to the handler */
   }
}


// Constructeur MainWindow
MainWindow::MainWindow(BRect r) : BWindow(r, "ToolsTester", B_TITLED_WINDOW_LOOK, B_NORMAL_WINDOW_FEEL, 
                                          B_NOT_RESIZABLE | B_NOT_ZOOMABLE )
{
   float    i_PrevBottom;
   BRect    c_ButtonRect;

   /* Main view */
   BView *MainView = new BView(Bounds(), "MainView", B_FOLLOW_LEFT,B_NAVIGABLE);
   MainView->SetViewColor(BG_COLOR);
   AddChild(MainView);

   /* Power Button */
   c_ButtonRect = Bounds();
   c_ButtonRect.left += 10;
   c_ButtonRect.right -= 10; 
   c_ButtonRect.top +=  20;
   c_ButtonRect.bottom = c_ButtonRect.top  + 20;
   pc_PowerButton = new BButton(c_ButtonRect, "PowerButton","Power",
         new BMessage(MSG_POWER), B_FOLLOW_LEFT, B_WILL_DRAW | B_NAVIGABLE);
   MainView->AddChild(pc_PowerButton);
   i_PrevBottom = c_ButtonRect.bottom;

   /* Mute Button */
   c_ButtonRect = Bounds();
   c_ButtonRect.left += 10;
   c_ButtonRect.right -= 10; 
   c_ButtonRect.top = i_PrevBottom + 20;
   c_ButtonRect.bottom = c_ButtonRect.top  + 20;

   pc_MuteButton = new BButton(c_ButtonRect, "MuteButton","Mute",
         new BMessage(MSG_MUTE),B_FOLLOW_LEFT,B_WILL_DRAW | B_NAVIGABLE);
   MainView->AddChild(pc_MuteButton);
   i_PrevBottom = c_ButtonRect.bottom;

   /* Volume up Button */
   c_ButtonRect = Bounds();
   c_ButtonRect.left += 10;
   c_ButtonRect.right -= 10; 
   c_ButtonRect.top = i_PrevBottom + 20;
   c_ButtonRect.bottom = c_ButtonRect.top  + 20;

   pc_VolUpButton = new BButton(c_ButtonRect, "VolUpButton","Vol Up",
         new BMessage(MSG_VOL_UP),B_FOLLOW_LEFT,B_WILL_DRAW | B_NAVIGABLE);
   MainView->AddChild(pc_VolUpButton);
   i_PrevBottom = c_ButtonRect.bottom;
   
   /* Volume down Button */
   c_ButtonRect = Bounds();
   c_ButtonRect.left += 10;
   c_ButtonRect.right -= 10; 
   c_ButtonRect.top = i_PrevBottom + 20;
   c_ButtonRect.bottom = c_ButtonRect.top  + 20;

   pc_VolDownButton = new BButton(c_ButtonRect, "VolDownButton","Vol Down",
         new BMessage(MSG_VOL_DOWN),B_FOLLOW_LEFT,B_WILL_DRAW | B_NAVIGABLE);
   MainView->AddChild(pc_VolDownButton);
   i_PrevBottom = c_ButtonRect.bottom;
   
   SetDefaultButton(pc_MuteButton);
   Show();
}

void MainWindow::MessageReceived(BMessage *message)
{
   char *utf_key, string[255];
   int size;
   BAlert *MyAlert;

   switch (message->what)
   {
      case MSG_MUTE:
         MyApp.ButtonPressed();
         break;

      case MSG_POWER:
         MyApp.PowerPressed();
         break;
      
      case MSG_VOL_UP:
         MyApp.VolumeUpPressed();
         break;

      case MSG_VOL_DOWN:
         MyApp.VolumeDownPressed();
         break;

      default:
         break;
   }
}

bool MainWindow::QuitRequested()
{
   be_app->PostMessage(B_QUIT_REQUESTED);
   return true;
}
