#include <Window.h>
#include <Application.h>
#include <Button.h>
#include <TextControl.h>
#include <Alert.h>
#include <String.h>
#include <stdio.h>
#include <View.h>
#include <GraphicsDefs.h>

#include "KeyTester.h"
#include "RcDefs.h"
#include "VolumeBar.h"

KeyTester gc_MainApp;
BTextControl *gc_MappedKeyText,*gc_UnmappedKeyText;

int main()
{
   gc_MainApp.Run();
   return 0;
}

KeyTester::KeyTester():BApplication("application/x-vnd.zadig.BercKeyTester")
{
   uint8 i;
   VolumeBar *p_Bar;
   
   p_Bar = new VolumeBar();
   for(i=0; i<16; i++)
   {
      p_Bar->SetVolumeLevel(i);
      snooze(3000000);
   }
}

#if 0
MainWindow::MainWindow(BRect r)  :
   BWindow(r, "KeyTester", B_TITLED_WINDOW_LOOK, 
            B_NORMAL_WINDOW_FEEL, 
            B_NOT_RESIZABLE | B_NOT_ZOOMABLE )
{
   BRect rButton,rNameText,rPwdText;

   rButton = Bounds();
   rButton.left += 50;
   rButton.right -= 50; 
   rButton.bottom -= 10;
   rButton.top = rButton.bottom - 20;

   rNameText = Bounds();
   rNameText.left -= 100;
   rNameText.right -= 30;
   rNameText.top += 10;
   rNameText.bottom = rNameText.top + 20;

   rPwdText = Bounds();
   rPwdText.left -= 100;
   rPwdText.right -= 30;
   rPwdText.top = rNameText.bottom + 10;
   rPwdText.bottom = rNameText.top + 20;

   //on cree le fond gris
   BView *MainView = new BView(Bounds(), "MainView", 
         B_FOLLOW_LEFT,B_NAVIGABLE);
   MainView->SetViewColor(BG_COLOR);
   AddChild(MainView);

   // mapped keys textfield
   gc_MappedKeyText = new BTextControl(rNameText, "MappedTextfield",
         "", "",NULL,B_FOLLOW_LEFT ,B_WILL_DRAW | B_NAVIGABLE);
   MainView->AddChild(gc_MappedKeyText);

   //unmapped keys textfield
   gc_UnmappedKeyText = new BTextControl(rPwdText, "UnmappedTextfield",
         "", "",NULL,B_FOLLOW_LEFT ,B_WILL_DRAW | B_NAVIGABLE);
   gc_UnmappedKeyText->SetEnabled(false);
   MainView->AddChild(gc_UnmappedKeyText);

   Show();
}

void MainWindow::MessageReceived(BMessage *message)
{
   char *utf_key, string[255], *ps_CustomString;
   int size;
   uint32   i_UnmappedKey;
   status_t i_Ret;

   switch (message->what)
   {
      case B_UNMAPPED_KEY_DOWN:
         if(message->FindInt32((const char*)"key", (int32*)&i_UnmappedKey) == B_OK)
         {
            if(i_UnmappedKey == RC_UNMAPPED_KEY_CUSTOM)
            {
               strcpy(string, "custom key error");
               size = 32;
               if(message->FindString("berc:custom_key", 
                                    (const char**)&ps_CustomString ) == B_OK)
               {
                  if(ps_CustomString != NULL)
                     strcpy(string, ps_CustomString);
               }

            }
            else
            {
               i_Ret = GetUnmappedString(i_UnmappedKey, (char*)string);
               if(i_Ret != B_OK)
                  sprintf(string, "Received unknown unmapped key %d",i_UnmappedKey);
            }
         }
         else
            sprintf(string,"Error while decoding unmapped byte string");
         gc_UnmappedKeyText->SetText(string);   
         break;
   }
}

bool MainWindow::QuitRequested()
{
   be_app->PostMessage(B_QUIT_REQUESTED);
   return true;
}

status_t MainWindow::GetUnmappedString(uint32 i_Message, char *sz_String)
{
   switch(i_Message)
   {
      case RC_KEY_A:
         strcpy(sz_String, "RC_KEY_A");
         break;
      case RC_KEY_B:
         strcpy(sz_String, "RC_KEY_B");
         break;
      case RC_KEY_C:
         strcpy(sz_String, "RC_KEY_C");
         break;
      case RC_KEY_D:
         strcpy(sz_String, "RC_KEY_D");
         break;
      case RC_KEY_E:
         strcpy(sz_String, "RC_KEY_E");
         break;
         
      case RC_KEY_BACK:
         strcpy(sz_String, "RC_KEY_BACK");
         break;
      case RC_KEY_MAIN:
         strcpy(sz_String, "RC_KEY_MAIN");
         break;
      case RC_KEY_INFO:
         strcpy(sz_String, "RC_KEY_INFO");
         break;

      case RC_KEY_POWER:
         strcpy(sz_String, "RC_KEY_POWER");
         break;
      case RC_KEY_MUTE:
         strcpy(sz_String, "RC_KEY_MUTE");
         break;         
      case RC_KEY_VOLUME_UP:
         strcpy(sz_String, "RC_KEY_VOLUME_UP");
         break;
      case RC_KEY_VOLUME_DOWN:
         strcpy(sz_String, "RC_KEY_VOLUME_DOWN");
         break;
         
      case RC_KEY_PLAY:
         strcpy(sz_String, "RC_KEY_PLAY");
         break;
      case RC_KEY_PAUSE:
         strcpy(sz_String, "RC_KEY_PAUSE");
         break;
      case RC_KEY_STOP:
         strcpy(sz_String, "RC_KEY_STOP");
         break;
      case RC_KEY_RECORD:
         strcpy(sz_String, "RC_KEY_RECORD");
         break;
      case RC_KEY_FORWARD:
         strcpy(sz_String, "RC_KEY_FORWARD");
         break;
      case RC_KEY_REWIND:
         strcpy(sz_String, "RC_KEY_REWIND");
         break;

      default:
         return(B_ERROR);
         break;
   }

   return(B_OK);
}
#endif
